import { DeepPartial } from '@azure-tools/codegen';
import { Access, New, ReadOnly, Static, Volitile } from './access-modifier';
import { Attribute } from './attribute';
import { Expression, ExpressionOrLiteral } from './expression';
import { OneOrMoreStatements, Statement } from './statements/statement';
import { TypeDeclaration } from './type-declaration';
import { Variable } from './variable';
/** represents a field in a Class */
export declare class Field extends Variable {
    name: string;
    type: TypeDeclaration;
    'new': New;
    access: Access;
    'static': Static;
    'readonly': ReadOnly;
    volitile: Volitile;
    attributes: Attribute[];
    initialValue?: ExpressionOrLiteral;
    protected get attributeDeclaration(): string;
    description: string;
    constructor(name: string, type: TypeDeclaration, objectInitializer?: DeepPartial<Field>);
    get declaration(): string;
    get value(): string;
    assign(expression: ExpressionOrLiteral): OneOrMoreStatements;
    assignPrivate(expression: ExpressionOrLiteral): OneOrMoreStatements;
    get declarationExpression(): Expression;
    get declarationStatement(): Statement;
}
//# sourceMappingURL=field.d.ts.map